#pragma once

#ifndef _GPS_H_
#define _GPS_H_

#define WM_RECEIVEDATA		WM_USER+10
#define WM_RECEIVEGPSDATA	WM_USER+11

#define GPM_GGA				0
#define GPM_GLL				1
#define GPM_GSA				2
#define GPM_GSV				3
#define GPM_RMC				4
#define GPM_VTG				5

//Rs232c ϱ  Ŭ  
// Flow control flags 
#define FC_DTRDSR 0x01 
#define FC_RTSCTS 0x02 
#define FC_XONXOFF 0x04 

// ascii definitions 
#define ASCII_BEL 0x07 
#define ASCII_BS 0x08 
#define ASCII_LF 0x0A 
#define ASCII_CR 0x0D 
#define ASCII_XON 0x11 
#define ASCII_XOFF 0x13 

class CGPS
{
public:
	CGPS(void);
	CGPS(int ComPort, DWORD BaudRate, BYTE ByteSize, BYTE Parity, BYTE StopBits);
	~CGPS(void);
private:
	GGA		m_GGA;
	GLL		m_GLL;
	GSA		m_GSA;
	RMC		m_RMC;
	VTG		m_VTG;
public:	
	int		PutRawData(const char* Data);
public:
	float	GetLatitude(void)		{ return m_GLL.Latitude;}
	float	GetLongitude(void)		{ return m_GLL.Logitude; }
	char	GetNSIndicator(void)	{ return m_GLL.NSIndicator; }
	char	GetEWIndicator(void)	{ return m_GLL.EWIndicator; }
	float	GetUTCPosition(void)	{ return m_GLL.UTCPosition; }
	char	GetStatus(void)			{ return m_GLL.Status;}
	GLL		GetGLLData(void)		{ return m_GLL;}
	int		SetupComPort(int ComPort, DWORD BaudRate, BYTE ByteSize, BYTE Parity, BYTE StopBits);
protected:
	char*	m_Data;
	char	m_seps[2];
	void	SetGLLData(char* Data);
	void	SetGGAData(char* Data);
	void	SetGSAData(char* Data);
	void	SetRMCData(char* Data);
	void	SetVTGData(char* Data);
	virtual int ParseData(const char* Data);
private:
	double	a2f(const char* Data);
	int		a2i(const char* Data);
	char	a2c(const char* Data);
protected:
	HWND	m_hWnd;
	USHORT	bPort;
	DWORD	dwBaudRate;
	BYTE	bByteSize;
	BYTE	bStopBits;
	BYTE	bParity;
	char GetNMEAChecksum(const char* Data);
};

#endif
