#ifndef _NMEA2_H_
#define _NMEA2_H_

typedef struct _GGA{
	char	MessageID[4];	
	float	UTCPosition;	
	float	Latitude;	
	char	NSIndicator;
	float	Longitude;	
	char	EWIndicator;	
	char	PositionFixIndicator;
	short	SatelliteUsed;
	float	HDOP;		
	float	MSLAltitude;	
	char	Units1;		
	char	GeoidSeperation;	
	char	Units2;		
	unsigned int	AgeOfDiff;	
	unsigned int	Checksum;	
} GGA;

typedef struct _GLL{
	char	MessageID[4];	
	float	Latitude;	
	char	NSIndicator;	
	float	Logitude;	
	char	EWIndicator;	
	float	UTCPosition;	
	char	Status;		
	unsigned int Checksum;	
} GLL;

typedef struct _GSA{
	char			MessageID[4];	
	char           Mode1;		
	char           Mode2;		
	unsigned short SatelliteUse1;	
	unsigned short SatelliteUse2;	
	unsigned short SatelliteUse3;	
	unsigned short SatelliteUse4;	
	unsigned short SatelliteUse5;	
	unsigned short SatelliteUse6;	
	unsigned short SatelliteUse7;	
	unsigned short SatelliteUse8;	
	unsigned short SatelliteUse9;	
	unsigned short SatelliteUse10;	
	unsigned short SatelliteUse11;	
	unsigned short SatelliteUse12;	
	float          PDOP;		
	float          HDOP;		
	float          VDOP;		
	unsigned int	Checksum;		
} GSA;

typedef struct _Satellite{
	unsigned short	SatelliteID;	
	unsigned short	Elevation;	
	unsigned short	Azimuth;	
	unsigned short	SNR;		
} Satellite;

typedef struct _GSV{
	char		MessageID[4];	
	char		NumOfMessage;	
	char		MessageNum;	
	unsigned short	SatelliteInView;	
	Satellite	Satelliste1;	
	Satellite	Satelliste2;	
	Satellite	Satelliste3;	
	Satellite	Satelliste4;	
	unsigned int    Checksum;	
} GSV;

typedef struct _RMC{
	char	MessageID[4];	
	float	UTCPosition;	
	char	Status;		
	float	Latitude;	
	char	NSIndicator;	
	float	Longitude;	
	char	EWIndicator;	
	float	SpeedOverGround;	
	float	CourseOverGorund;
	unsigned int	Date;		
	unsigned int	MagneticVariation;
	unsigned int	Checksum;
} RMC;

typedef struct _VTG{
	char	MessageID[4];
	float	Course1;	
	char	Reference1;	
	float	Course2;		
	char	Reference2;	
	float	Speed1;		
	char	Units1;		
	float	Speed2;		
	char	Units2;		
	unsigned int	Checksum;
} VTG;

#endif	// _NMEA2_H_